set -o pipefail
retval=0

for f in `find "$RPM_BUILD_ROOT" -iname .dwz -prune -o -type f -executable -print`; do \
    echo "RPM LLVM-BOLT GADGET SCANNER: $f"
    log_file=`mktemp`
    if ! /usr/bin/llvm-bolt-gadget-scanner  --noreturnfuncs="__GI___libc_fatal/1,malloc_printerr/1,__GI___chk_fail/1,_ _GI___assert_fail/1,__stack_chk_fail_local/1,__stack_chk_fail@PLT,abort@PLT,__assert_fail@PLT,_ZSt21__glibcxx_assert_failPKciS0_S0_@PLT,__cxa_throw@PLT,_Unwind_Resume@PLT" $f | tee $log_file; then
        echo "$f: Gadget Scanner Failed!"
        retval=1
    fi
    if grep -q -e 'GS-PACRET:' -e 'GS-STACKCLASH:' $log_file; then
        echo "$f: Possible incomplete hardening"
        retval=1
    fi
    rm $log_file
done

exit $retval
